'FFSubmenu=Skalieren
'FFName=Formatnormierung

' ********************************************************************
' Formatnormierung.vbs (Skript fr FixFoto)
' von Harald Maeckler, Dsseldorf 2009 - 2016
'
' Funktion:	Bilder werden  auf ein festzulegendes Format normiert.
'			Dabei werden die Bilder  entweder beschnitten, fehlende Bereiche durch einen Rahmen
'  			bzw. gespiegelte Bildanteile ersetzt oder verzerrt und danach proportional skaliert.
'			Auf Wunsch knnen dabei zwei Bilder zu einem Bild zusammengefasst werden.
'
' Version 2.22 vom 11.04.2016	- Bug bei "durch Beschnitt / bei Abbruch durch Farbrand" beseitigt.
'									Bei Beantwortung der Abfrage nach Abbruch des Scnittdialogs mit 'Nein'
'									wurde flschlicherweise die Abarbeitung der Bilder nicht fortgesetzt
' Version 2.21 vom 25.03.2016	- Aktivierung und Deaktivierung von Steuerelementen vereinfacht
'								- kleine Schnheitsfehler beseitigt
' Version 2.20 vom 23.03.2016	- Formatanpassung durch Beschnitt / bei Abbruch durch Farbrand
'								- berarbeitung der Kurzbeschreibung
' Version 2.14 vom 21.03.2016	- Skript-URL gem Forenberarbeitung gendert
'								- Umrandung immer direkt um das Bild
'								- Hintergrundfarbe bei Erweiterung separat definierbar
' Version 2.13 vom 26.06.2014	- Formatanpassung durch Spiegelung hinzugefgt
' Version 2.12 vom 24.01.2014	- Schnittrahmen im Schnittdialog mittig gesetzt
' Version 2.11 vom 04.11.2013	- Bug bei Freischaltung des Bildverhlnisses beseitigt
' Version 2.10 vom 26.08.2013	- bei Option 'durch Rand vergrern' kann jetzt die Lage
'									der Randvergrerung gewhlt werden 
'									(links bzw. oben oder rechts bzw. unten / wenn beide aktiv dann mittig)
'								- Neu: Option 'Bild mit Freiflche'
'									Bei den Optionen 'durch Beschneiden' und 'durch Verzerren'
'									wird das Bild in der Gre so verndert, dass im gewhlten Verhltnis
'									eine Freiflche mit der gewhlten Hintergrundfarbe entsteht.
'									Die Lage der Freiflche entspricht der Einstellung bei der
'									Option 'durch Rand vergrern'.
'								- Update-Funktion aktualisiert
'								- Kurzbeschreibung angepasst
' Version 2.09 vom 01.11.2012	- Bugs im PDF-Aufruf und der Lschfunktion behoben
' Version 2.08 vom 31.10.2012	- Updatefunktion
'								- Tooltips
'								- PDF-Beschreibung
'								- Option 'Quer- bzw. Hochformat erhalten' hinzu
' Version 2.07 vom 07.01.2012	- Prfix ausschaltbar
' Version 2.06 vom 04.01.2012	- Kurzbeschreibung ergnzt bezglich Unterbrechung mit 'Backspace'
' Version 2.05 vom 12.01.2010	- Option 'Nicht automatisch speichern' hinzu
' Version 2.04 vom 04.12.2009	- Korrektur beim Aufruf des Dialogs Ausschneiden
' Version 2.03 vom 03.12.2009	- bei 'Anordnung paarig'
'									-  Stegbreite unabhngig von der Randbreite eingebbar
'									-  bei Formatanpassung durch 'Beschneiden' oder 'Verzerren'
'									   kann das Breitenverhltnis Bild1 zu Bild2 gewhlt werden
' Version 2.02 vom 29.11.2009	- Auswahl der Formatanpassung auch bei 'Anordnung paarig'
'								- im Dialog 'Ausschneiden' gewhlte Markierung bleibt erhalten
' Version 2.01 vom 11.11.2009	- Filter fr Quer- und Hochformat
' Version 2.00 vom 06.11.2009	- Auswahl der Formatanpassung
'								  Bei "Anordnung paarig" ist nur 'durch Rand vergrern' zugelassen
' Version 1.06 vom 02.11.2009	- Fehler bei Nummerierung gleicher Dateinamen beseitigt
' Version 1.05 vom 02.11.2009	- Auswahl Ablageordner wird mit aktuellem Verzeichnis gestartet
' Version 1.04 vom 30.10.2009	- Lschroutine
' Version 1.03 vom 29.10.2009	- Kurzbeschreibung
' Version 1.02 vom 27.10.2009	- Speicheroptionen
' Version 1.01 vom 26.10.2009	- Nachschrfung
' Version 1.00 vom 22.10.2009	- Betaversion
'
'** Start Kurzbeschreibung *******************************************
' Formatnormierung / Version 2.22
' ====================
' Bilder werden  auf ein festzulegendes Format normiert, vorzugsweise ein Querformat. Dabei
' werden die Bilder entweder beschnitten, fehlende Bereiche durch eine Freiflche ersetzt oder
' verzerrt und danach proportional skaliert.
' Auf Wunsch knnen dabei zwei Bilder zu einem Bild zusammengefasst werden.
'
' Die Formatnormierung wird mit Klick auf 'Start' begonnen.
'
' Will man die Abarbeitung mehrerer Bilder vorzeitig abbrechen, muss man
' 
' 	- bei Formatanpassung durch 'Beschneiden'
' den angezeigtem Ausschneidedialog bei festgehaltener 'Backspace'-Taste mit 'Ausfhren' ab-
' schlieen. Ist dabei die Option 'Anordnung paarig mit Steg' aktiviert, ist die Unterbrechung
' nur bei jedem zweiten Bild mglich.
'
'	- bei Formatanpassung durch 'Farbrand' oder 'Spiegelung' oder 'Verzerren'
' die Taste 'Backspace' bettigen und festhalten bis eine Rckmeldung erfolgt.
'
' Nach erfolgreicher Unterbrechung wird angezeigt, wie viel Bilder bisher bearbeitet wurden und
' es wird abgefragt, ob man die Formatnormierung beenden mchte.
'
' Auswahl
' ----------
' Man kann sich entscheiden, ob alle oder nur markierte Bilder der Computeransicht oder
' der aktiven Bilderliste geprft werden sollen. Die Bearbeitung von Fotos in einer Bilderliste
' ist allerdings erst ab FixFoto-Version 2.90 mglich. Ist eine ltere Version installiert,
' erfolgt ein entsprechender Hinweis.
' 
' Zielvorgaben
' ----------------
' Mit Breite und Hhe wird das Zielformat festgelegt, das mglichst ein Querformat sein 
' sollte. Mit der Umrandung wird vorgegeben, ob das Bild bzw. Bildpaar einen Rand mit einer
' Mindestbreite haben soll. Der Umrandungswert kann auch 0 sein.
' Die Randfarbe bestimmt, unabhngig von der Randbreite, auch die Stegfarbe bei paariger
' Anordnung. Die Hintergrundfarbe gilt fr die Option 'Freiflche' und die Formatanpassung
' 'durch Farbrand'.
' Mit 'Anordnung paarig' wird veranlasst, dass aus jeweils zwei Bildern ein Kombinations-
' bild erzeugt wird. Die Mindeststegbreite zwischen den beiden Bildern ist eingebbar, der Wert
' kann auch 0 sein.
' Bei 'Bild mit Freiflche' wird ein Bild im gewhlten Verhltnis zur eingestellten Gesamtgre
' auf der Bildgesamtflche in Hintergrundfarbe erzeugt.
'
' Tipp
' ===
' Man kann mit dem Skript 'Seitenverhltnis' ab Version 2.07 sehr einfach die hochformatigen
' Bilder aus einem Verzeichnis ausfiltern indem man auf Querformat testet und die nichtkon-
' formen Bilder in eine Bilderliste bertragen lsst. In dieser Liste ordnet man die Bilder
' durch Verschieben paarweise wie gewnscht an und fhrt dann das Skript 'Formatnormierung'
' mit 'Anordnung paarig' aus.
'
' Formatfilter
' --------------
' Es kann festgelegt werden, dass nur hochformatige oder nur querformatige Bilder bearbeitet
' werden. Quadratische Bilder werden wie hochformatige behandelt.
' Ist weder 'nur querformatige Bilder' noch 'nur hochformatige Bilder' aktiviert oder 'Quer-
' bzw. Hochformate erhalten' ausgewhlt, werden alle Bilder bearbeitet.
'
' Die Option 'Quer- bzw. Hochformate erhalten' bewirkt, dass Quer- und Hochformate bei der
' Formatanpassung beibehalten werden. Wenn es zur Erhaltung der Formatorientierung notwendig
' ist, werden dafr die Zielvorgaben fr Breite und Hhe getauscht.
' Bei aktivierter Option 'Anordnung paarig' oder 'Bild mit Freiflche' ist diese Option 
' gesperrt.
'
' Formatanpassung
' ---------------------
' Es kann zwischen den folgenden vier Methoden gewhlt werden:
'
' - 'durch Beschnitt / bei Abbruch Erw. durch Farbrand
'	Es wird die Methode 'durch Beschneiden' angewendet (siehe unten).
'	Wird der Beschnitt durch 'Schlieen' des Schnittdialogs abgebrochen, erfolgt eine Abfrage
'	ob die Methode 'durch Farbrand' (siehe unten) angewendet werden soll. Mit 'Ja' wird dies
'	durchgefhrt, mit 'Nein' wird die Bearbeitung des Bildes bersprungen.
' - 'durch Farbrand' oder 'durch Spiegelung'
'   Beide Arten der Formatanpassung sind bei Aktivierung von 'paarig mit Steg' oder 'Bild mit
'   Freiflche' nicht mglich.
'   Es wird in der Vertikalen oder Horizontalen die notwendige Vergrerung des Randes be-
'   rechnet und dieser automatisch durchgefhrt. Die Zusatzflche wird gem den aktivierten
'   Optionen 'links/oben' und 'rechts/unten' angeordnet. Ist beides aktiviert wird die Zusatz-
'   flche gleichmig auf den linken und rechten Rand verteilt.
'
' - 'durch Beschneiden'
'   Nach Start wird ein Ausschneidedialog aufgerufen, in dem proportional vernderbar ein Aus-
'   schnitt gewhlt und dann das Bild entsprechend beschnitten werden kann.
'   Wird kein Beschnitt durchgefhrt wird die Bearbeitung des Bildes bersprungen.
'   Bei 'Anordnung paarig' wird nach dem Beschneiden des ersten Bildes direkt danach der Dialog
'   Ausschneiden nochmals fr das zweite Bild aufgerufen. Wird hier kein Beschnitt durchgefhrt,
'   wird das betroffene Bildpaar bersprungen.
'
'   Anmerkung
'   =======
'   - Die im Dialog Ausschneiden gewhlte Markierung wird beibehalten bis zur Wahl einer anderen
'     Markierung.
'   - Soll ein querformatiges Bild hochformatig beschnitten werden oder umgekehrt, erfolgt vor
'     dem Aufruf des Dialogs ein entsprechender Hinweis mit der zustzlichen Anmerkung:
'
'          "Daher muss im folgenden Dialog die Taste 'Hoch/Quer' bettigt werden!"
'          ============================================
'
'     Dies muss im Ausschneidedialog unbedingt vor jeder anderen Handlung beachtet werden.
'             ===
'
' - 'durch Verzerren'
'   Die Bilder werden automatisch so gestreckt bzw. gestaucht, dass die notwendigen Bildgren
'   zur formatfllenden Darstellung erreicht werden.
'
' -	Verhltnis Bild 1 zu Bild 2 bzw. zur Freiflche
'   Bei 'paariger Anordnung' kann das Verhltnis der beiden Bildbreiten zueinander bzw. bei
'   'Bild mit Freiflche' das Verhltnis von Bild zu Freiflche zwischen 30:70 und 70:30 in 5er
'   Schritten gewhlt werden. Der prozentuale Anteil des ersten Bildes ergibt sich aus der Formel
'   B1_Ist / H1_Ist / (B1_Ist / H1_Ist + B2_Ist / H2_Ist) x 100, der des zweiten Bildes bzw. der
'   Freiflche aus der Differenz zu 100.
'
' Speicheroptionen
' ---------------------
' Die Speicherqualitt sollte zwischen 70 und 100 liegen. Bei der Vorgabe 0 wird die in FF
' fr JPG-Bildern eingestellte Speicherqualitt verwendet; bei TIFF-Bildern wird bei 0 nicht 
' komprimiert.
' Ist 'Exif + IPTC lschen' aktiviert, werden diese Daten gelscht.
' Bei 'paariger Anordnung' werden Exif- und IPTC-Daten  immer gelscht. Bei deaktiviertem 
' 'Exif + IPTC lschen' werden anschlieend neue Exif-Daten angelegt und dort die Daten 
' 'Fotograf', 'Copyright1' und 'Copyright2' des ersten Bildes eingetragen. Auerdem werden
' unter 'Kommentar' die Namen beider Bilder nach dem Muster 'Bildpaar Bild1 und Bild2' auf-
' gefhrt.
'
' Nachschrfung
' ------------------
' Nach einer Verkleinerung sollte immer nachgeschrft werden. Man kann hier einstellen, ob und
' mit welcher Strke die Y- und RGB-Schrfung angewendet werden soll. Natrlich ist es jedem 
' frei gestellt nach der Verwendung des Skripts individuell zu schrfen.
'
' Ablageordner
' ----------------
' Alle mit dem Skript erzeugten Bilder werden im gewhlten Ablageordner gespeichert. Als Name
' wird bei 'paariger Anordnung' der Name des ersten Bildes mit dem Prfix "FN2_" verwendet,
' sonst wird der Bildname mit dem Prfix "FN1_" benutzt. Die Prfix kann ausgeschaltet werden.
'
' Ist ein Bild im Ablageordner bereits vorhanden, wird dem Bildernamen eine Nummerierung nach 
' dem Muster (1), (2) usw. angehngt.
' Der DPI-Wert aller Bilder wird vor dem Abspeichern auf 72 gesetzt. Dadurch wird erreicht, dass
' in den Exif-Daten berall der gleiche DPI-Wert eingetragen ist.
'
' Nicht automatisch speichern
' ----------------------------------
' Ist diese Option aktiviert werden von den ausgewhlten Bildern nur das erste bzw. bei 'paariger
' Anordnung' die ersten beiden Bilder bearbeitet. Das Ergebnis wird nach Beendigung des Skript-
' durchlaufs angezeigt. Das Speichern muss manuell vorgenommen werden.
' Dies ist besonders dann interessant, wenn man bei 'paariger Anordnung' verschiedene Breitenver-
' hltnisse von Bild 1 zu Bild 2 testen mchte.
'
'
' Deinstallation des Skripts 'Formatnormierung'
' ===========================
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen ange-
' boten, davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach 
' wird die Skriptdatei gelscht und abschlieend die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript aus 
' der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ********************************************

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "2.22"
const SkriptURL = "http://www.ffsf.de/resources/formatnormierung.151/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

const SkriptName = "Formatnormierung.vbs"			'Skriptname
const RegSchluessel = "FF_Formatnormierung"			'Registryschlssel

Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung
Dim Anzeige
const ForReading = 1, ForWriting = 2, ForAppending = 8

Dim SkriptKill,Antwort,TempFile								'Lschroutine

Dim n,img,Auswahl,ListeBilder,Bild1,Bild2,Anzahl,nHoch,nQuer,Nur1x
Dim WertBreite,WertHoehe,WertRand,FarbFaktor,FarbWert,FarbFaktorHG,FarbWertHG,boolPaarig,WertSteg,boolFreiflaeche
Dim Bilder,BildNeu
Dim Qualitaet,boolExifLoeschen
Dim boolYSch,boolRGB,WertYSch,WertRGB
Dim Ablage,Folder,Kommentar
Dim AnpassKennung,flagRandV,flagRandS,boolLiOb,boolReUn,flagBeschnitt,flagVerzerr,flagBSaltEW
Dim flagQuer,flagHoch,flagQH,flagQH_erhalten,RV_flag,RV_Aktion,RV_AktionImmer,Bild2InBearbeitung,Markierung,B1zuB2,notPraefix
const VB1zuB2 = "30:70/35:65/40:60/45:55/50:50/55:45/60:40/65:35/70:30"	'/Orig.-V." ab V 2.010 entfernt
const Praefix1 = "FN1_" : const Praefix2 = "FN2_"

Dim objFS,WshShell

Abbruch = false
'---------------------------------------------------------------------
call main
'---------------------------------------------------------------------
Sub main
Dim msg

Anzahl = 0 : RV_AktionImmer = false

Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	n = FF_GetImageCount
 	if Err.Number = 500 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

'** Start Dialog Formatnormierung **
FF_AddDialog "Formatnormierung",280,208
FF_AddControl "Formatnormierung","Auswahl","GROUP",5,5,118,50
FF_AddControl "Formatnormierung","allCV","BOOL",10,14,8,8
FF_SetControlStyle "Formatnormierung","allCV",16384
FF_AddControl "Formatnormierung","alle Bilder der Computer-Ansicht","STATIC",21,13,96,10
FF_AddControl "Formatnormierung","selCV","BOOL",10,24,8,8
FF_SetControlStyle "Formatnormierung","selCV",16384
FF_AddControl "Formatnormierung","markierte Bilder der Computer-Ansicht","STATIC",21,23,96,10
FF_AddControl "Formatnormierung","allBL","BOOL",10,34,8,8
FF_SetControlStyle "Formatnormierung","allBL",16384
FF_AddControl "Formatnormierung","alle Bilder der aktiven Bilderliste","STATIC",21,33,96,10
FF_AddControl "Formatnormierung","selBL","BOOL",10,44,8,8
FF_SetControlStyle "Formatnormierung","selBL",16384
FF_AddControl "Formatnormierung","markierte Bilder der aktiven Bilderliste","STATIC",21,43,96,10
FF_AddControl "Formatnormierung","Zielvorgaben","GROUP",127,5,148,50
FF_AddControl "Formatnormierung","Breite","STATIC",133,14,16,10
FF_AddControl "Formatnormierung","WertBreite","SLEDIT",153,14,25,10
FF_SetControlStyle "Formatnormierung","WertBreite",8193
FF_AddControl "Formatnormierung","x  Hhe","STATIC",182,14,19,10
FF_AddControl "Formatnormierung","WertHoehe","SLEDIT",205,14,25,10
FF_SetControlStyle "Formatnormierung","WertHoehe",8193
FF_AddControl "Formatnormierung","px","STATIC",232,13,9,10
FF_AddControl "Formatnormierung","Umrandung","STATIC",132,27,34,10
FF_AddControl "Formatnormierung","WertRand","SLEDIT",162,27,16,10
FF_SetControlStyle "Formatnormierung","WertRand",8193
FF_AddControl "Formatnormierung","px      in","STATIC",182,27,19,10
FF_AddControl "Formatnormierung","WertFarbe","COLOR",205,27,25,11
FF_AddControl "Formatnormierung","s1","STATIC",242,11,1,32
FF_SetControlStyle "Formatnormierung","s1",18
FF_AddControl "Formatnormierung","Farbe","STATIC",245,18,28,8
FF_SetControlStyle "Formatnormierung","Farbe",1
FF_AddControl "Formatnormierung","Rand","STATIC",249,40,21,10
FF_AddControl "Formatnormierung","boolPaarig","BOOL",132,44,8,8
FF_SetControlStyle "Formatnormierung","boolPaarig",16384
FF_AddControl "Formatnormierung","paarig mit Steg","STATIC",143,43,39,10
FF_AddControl "Formatnormierung","WertSteg","SLEDIT",184,43,16,10
FF_SetControlStyle "Formatnormierung","WertSteg",8193
FF_AddControl "Formatnormierung","px|","STATIC",202,43,9,10
FF_AddControl "Formatnormierung","boolFreiflaeche","BOOL",217,44,8,8
FF_SetControlStyle "Formatnormierung","boolFreiflaeche",16384
FF_AddControl "Formatnormierung","Bild mit Freiflche","STATIC",228,43,42,10
FF_AddControl "Formatnormierung","Speicheroptionen","GROUP",5,100,118,37
FF_AddControl "Formatnormierung","Speicherqualitt","STATIC",21,107,48,10
FF_AddControl "Formatnormierung","Qualitaet","SLEDIT",65,107,16,10
FF_SetControlStyle "Formatnormierung","Qualitaet",8193
FF_AddControl "Formatnormierung","Wert 0 =","STATIC",88,105,31,8
FF_AddControl "Formatnormierung","FF-Einstellung","STATIC",85,111,35,10
FF_AddControl "Formatnormierung","boolExifLoeschen","BOOL",10,120,8,8
FF_SetControlStyle "Formatnormierung","boolExifLoeschen",16384
FF_AddControl "Formatnormierung","Exif + IPTC lschen","STATIC",21,118,99,10
FF_AddControl "Formatnormierung","Nachschrfung","GROUP",127,116,148,21
FF_AddControl "Formatnormierung","boolYSch","BOOL",212,125,8,8
FF_AddControl "Formatnormierung","Y-Schrfe","STATIC",224,124,26,10
FF_AddControl "Formatnormierung","WertYSch","SLEDIT",254,124,16,10
FF_SetControlStyle "Formatnormierung","WertYSch",8193
FF_AddControl "Formatnormierung","boolRGB","BOOL",132,125,8,8
FF_AddControl "Formatnormierung","RGB-Schrfe","STATIC",143,124,48,10
FF_AddControl "Formatnormierung","WertRGB","SLEDIT",178,124,16,10
FF_SetControlStyle "Formatnormierung","WertRGB",8193
FF_AddControl "Formatnormierung","Formatfilter","GROUP",5,56,118,42
FF_AddControl "Formatnormierung","flagQuer","BOOL",10,66,8,8
FF_SetControlStyle "Formatnormierung","flagQuer",16384
FF_AddControl "Formatnormierung","nur querformatige Bilder","STATIC",21,65,94,10
FF_AddControl "Formatnormierung","flagHoch","BOOL",10,76,8,8
FF_SetControlStyle "Formatnormierung","flagHoch",16384
FF_AddControl "Formatnormierung","nur hochformatige Bilder","STATIC",21,75,94,10
FF_AddControl "Formatnormierung","flagQH_erhalten","BOOL",10,86,8,8
FF_SetControlStyle "Formatnormierung","flagQH_erhalten",16384
FF_AddControl "Formatnormierung","Quer- bzw. Hochformat erhalten","STATIC",21,85,94,10
FF_AddControl "Formatnormierung","Formatanpassung","GROUP",127,56,148,59
FF_AddControl "Formatnormierung","flagBeschnitt","BOOL",132,95,8,8
FF_SetControlStyle "Formatnormierung","flagBeschnitt",16384
FF_AddControl "Formatnormierung","durch Beschneiden","STATIC",143,94,48,10
FF_AddControl "Formatnormierung","flagRandV","BOOL",132,75,8,8
FF_SetControlStyle "Formatnormierung","flagRandV",16384
FF_AddControl "Formatnormierung","durch Farbrand","STATIC",143,74,38,10
FF_AddControl "Formatnormierung","flagRandS","BOOL",185,75,8,8
FF_SetControlStyle "Formatnormierung","flagRandS",16384
FF_AddControl "Formatnormierung","d.Spiegelung","STATIC",196,74,32,10
FF_AddControl "Formatnormierung","==>","STATIC",131,83,14,10
FF_AddControl "Formatnormierung","boolLiOb","BOOL",146,85,8,8
FF_SetControlStyle "Formatnormierung","boolLiOb",16384
FF_AddControl "Formatnormierung","links/oben","STATIC",157,84,28,10
FF_AddControl "Formatnormierung","boolReUn","BOOL",185,85,8,8
FF_SetControlStyle "Formatnormierung","boolReUn",16384
FF_AddControl "Formatnormierung","rechts/unten","STATIC",196,84,32,10
FF_AddControl "Formatnormierung","flagVerzerr","BOOL",132,105,8,8
FF_SetControlStyle "Formatnormierung","flagVerzerr",16384
FF_AddControl "Formatnormierung","durch Verzerren","STATIC",143,104,42,9
FF_AddControl "Formatnormierung","s2","STATIC",198,96,1,15
FF_SetControlStyle "Formatnormierung","s2",18
FF_AddControl "Formatnormierung",">>>>>>","STATIC",202,99,26,9
FF_AddControl "Formatnormierung","s3","STATIC",231,75,1,36
FF_SetControlStyle "Formatnormierung","s3",18
FF_AddControl "Formatnormierung","Bild 1 zu Bild 2","STATIC",236,75,36,8
FF_SetControlStyle "Formatnormierung","Bild 1 zu Bild 2",1
FF_AddControl "Formatnormierung","bzw. zur","STATIC",236,82,36,8
FF_SetControlStyle "Formatnormierung","bzw. zur",1
FF_AddControl "Formatnormierung","Freiflche","STATIC",236,89,36,8
FF_SetControlStyle "Formatnormierung","Freiflche",1
FF_AddControl "Formatnormierung","B1zuB2","COMBO",237,99,33,9
FF_AddControl "Formatnormierung","Ablageordner","GROUP",5,141,270,27
FF_AddControl "Formatnormierung","Ablage","SLEDIT",10,151,242,10
FF_SetControlStyle "Formatnormierung","Ablage",2048
FF_AddControl "Formatnormierung","...","BUTTON",257,151,10,10
FF_AddControl "Formatnormierung","boolNichtSpeichern","BOOL",10,170,8,8
FF_SetControlStyle "Formatnormierung","boolNichtSpeichern",16384
FF_AddControl "Formatnormierung","Nicht automatisch speichern - nur erstes Bild bzw. Bildpaar bearbeiten","STATIC",21,169,218,10
FF_AddControl "Formatnormierung","notPraefix","BOOL",232,170,8,8
FF_AddControl "Formatnormierung","Prfix aus","STATIC",242,169,26,10
FF_AddControl "Formatnormierung","Fortschritt","PROGRESS",5,181,270,4
FF_AddControl "Formatnormierung","?","BUTTON",8,191,11,11
FF_AddControl "Formatnormierung","|","STATIC",21,191,24,11
FF_SetControlStyle "Formatnormierung","|",1
FF_AddControl "Formatnormierung","Update","BUTTON",47,191,33,11
FF_AddControl "Formatnormierung","Abbruch mit","STATIC",96,191,31,11
FF_AddControl "Formatnormierung","Backspace","BUTTON",127,192,32,9
FF_AddControl "Formatnormierung","- Taste","STATIC",160,191,23,11
FF_AddControl "Formatnormierung","Abbrechen","BUTTON",200,191,30,11
FF_AddControl "Formatnormierung","Start","BUTTON",242,191,28,11
FF_AddControl "Formatnormierung","&d","BUTTON",5,207,1,1
FF_AddControl "Formatnormierung","HgFarbe","COLOR",246,27,25,11
FF_AddControl "Formatnormierung","flagBSaltEW","BOOL",132,65,8,8
FF_SetControlStyle "Formatnormierung","flagBSaltEW",16384
FF_AddControl "Formatnormierung","durch Beschnitt / bei Abbruch durch Farbrand","STATIC",143,64,126,10
FF_AddControl "Formatnormierung","Hintergrd.-","STATIC",245,9,28,8
FF_SetControlStyle "Formatnormierung","Hintergrd.-",1
FF_AddControl "Formatnormierung","( bei paariger Anordnung siehe ? )","STATIC",20,127,94,8
'** End Dialog Formatnormierung **

call RegistryLesen
if Abbruch then exit sub

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Formatnormierung","Qualitaet", "" &_
						 "Qualitt der normierten Bilder." & vbNewLine & "Bei 0 wird die FixFoto-Einstellung verwendet."
	FF_SetControlTooltip "Formatnormierung","Ablage",Ablage
	FF_SetControlTooltip "Formatnormierung","...","Aufruf des Dateiexplorers"
	FF_SetControlTooltip "Formatnormierung","?", "" &_
						 "Anzeige der Kurzbeschreibung als PDF-Datei," & vbNewLine & _
						 "vorausgesetzt es ist ein PDF-Reader installiert." & vbNewLine & _
						 "Anderenfalls wird eine gekrzte Textversion angezeigt."
	FF_SetControlTooltip "Formatnormierung","Update", "" &_
						 "Prfung ob eine neue Version vorliegt."
	FF_SetControlTooltip "Formatnormierung","Backspace", "" &_
						 "Vorzeitiger Abbruch mglich durch" & vbNewLine & "'Ausfhren' des Ausschneidedialogs" & vbNewLine &_
						 "bei festgehaltener 'Backspace'-Taste." & vbNewLine & vbNewLine &_
						 "Bei paariger Anordung ist der Abbruch" & vbNewLine & "nur bei jedem zweiten Bild mglich."
	FF_SetControlTooltip "Formatnormierung","Abbrechen", "" &_
						 "Vorzeitiges Beenden des Skripts"
	FF_SetControlTooltip "Formatnormierung","Start", "" &_
						 "Start der Formatnormierung"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 2500
FF_ActivateControl "Formatnormierung","&d"
FF_SetDialogTimer "Formatnormierung", 100

do
	Select Case FF_ShowDialog ("Formatnormierung")
	Case "TIMER"
		FF_SetControl "Formatnormierung" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "Formatnormierung", 0
	Case "&d"
		Abbruch = false
		SkriptKill = false
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "mit allen dazugehrigen Komponenten wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "allCV"		'Auswahl alle in der Comp.-Ansicht
		Auswahl = 0
		FF_SetControl "Formatnormierung","allCV",1
		FF_SetControl "Formatnormierung","selCV",0
		FF_SetControl "Formatnormierung","allBL",0
		FF_SetControl "Formatnormierung","selBL",0
	Case "selCV"		'Auswahl markierte in der Comp.-Ansicht
		Auswahl = 1
		FF_SetControl "Formatnormierung","allCV",0
		FF_SetControl "Formatnormierung","selCV",1
		FF_SetControl "Formatnormierung","allBL",0
		FF_SetControl "Formatnormierung","selBL",0	
	Case "allBL"		'Auswahl alle in der aktuellen Bilderliste
		Auswahl = 2
		FF_SetControl "Formatnormierung","allCV",0
		FF_SetControl "Formatnormierung","selCV",0
		FF_SetControl "Formatnormierung","allBL",1
		FF_SetControl "Formatnormierung","selBL",0	
	Case "selBL"		'Auswahl markierte in der aktuellen Bilderliste
		Auswahl = 3
		FF_SetControl "Formatnormierung","allCV",0
		FF_SetControl "Formatnormierung","selCV",0
		FF_SetControl "Formatnormierung","allBL",0
		FF_SetControl "Formatnormierung","selBL",1
	
	Case "flagQuer"
		if FF_GetControl("Formatnormierung","flagQuer") = 1 then
			FF_SetControl "Formatnormierung","flagHoch",0
			FF_SetControl "Formatnormierung","flagQH_erhalten",0
		end if
	Case "flagHoch"
		if FF_GetControl("Formatnormierung","flagHoch") = 1 then
			FF_SetControl "Formatnormierung","flagQuer",0
			FF_SetControl "Formatnormierung","flagQH_erhalten",0
		end if
	Case "flagQH_erhalten"
		if FF_GetControl("Formatnormierung","flagQH_erhalten") = 1 then
			FF_SetControl "Formatnormierung","flagQuer",0
			FF_SetControl "Formatnormierung","flagHoch",0
		end if
	
	Case "boolPaarig"
		if FF_GetControl("Formatnormierung","boolPaarig") = 1 then
			FF_EnableControl "Formatnormierung","WertSteg",true
			FF_SetControl "Formatnormierung","boolFreiflaeche",0
			FF_SetControl "Formatnormierung","flagQH_erhalten",0
			FF_EnableControl "Formatnormierung","flagQH_erhalten",false
		else
			FF_EnableControl "Formatnormierung","flagQH_erhalten",true
		end if
	Case "boolFreiflaeche"
		if FF_GetControl("Formatnormierung","boolFreiflaeche") = 1 then
			FF_SetControl "Formatnormierung","boolPaarig",0
			FF_SetControl "Formatnormierung","flagQH_erhalten",0
			FF_EnableControl "Formatnormierung","flagQH_erhalten",false
		else
			FF_EnableControl "Formatnormierung","flagQH_erhalten",true
		end if

	Case "flagBSaltEW"
		FF_SetControl "Formatnormierung","flagBSaltEW",1
		FF_SetControl "Formatnormierung","flagRandV",1
		FF_SetControl "Formatnormierung","flagRandS",0
		FF_SetControl "Formatnormierung","flagBeschnitt",0
		FF_SetControl "Formatnormierung","flagVerzerr",0
		FF_EnableControl "Formatnormierung","boolPaarig",false
		FF_EnableControl "Formatnormierung","WertSteg",false
		FF_EnableControl "Formatnormierung","boolFreiflaeche",false
		FF_EnableControl "Formatnormierung","flagQH_erhalten",true
	Case "flagRandV"
		FF_SetControl "Formatnormierung","flagRandV",1
		FF_SetControl "Formatnormierung","flagRandS",0
		FF_SetControl "Formatnormierung","flagBSaltEW",0
		FF_SetControl "Formatnormierung","flagBeschnitt",0
		FF_SetControl "Formatnormierung","flagVerzerr",0
		FF_EnableControl "Formatnormierung","boolPaarig",false
		FF_EnableControl "Formatnormierung","WertSteg",false
		FF_EnableControl "Formatnormierung","boolFreiflaeche",false
		FF_EnableControl "Formatnormierung","flagQH_erhalten",true
	Case "flagRandS"
		FF_SetControl "Formatnormierung","flagRandS",1
		FF_SetControl "Formatnormierung","flagRandV",0
		FF_SetControl "Formatnormierung","flagBSaltEW",0
		FF_SetControl "Formatnormierung","flagBeschnitt",0
		FF_SetControl "Formatnormierung","flagVerzerr",0
		FF_EnableControl "Formatnormierung","boolPaarig",false
		FF_EnableControl "Formatnormierung","WertSteg",false
		FF_EnableControl "Formatnormierung","boolFreiflaeche",false
'	Case "boolLiOb"
'	Case "boolReUn"
	Case "flagBeschnitt"
		FF_SetControl "Formatnormierung","flagBeschnitt",1
		FF_SetControl "Formatnormierung","flagBSaltEW",0
		FF_SetControl "Formatnormierung","flagRandV",0
		FF_SetControl "Formatnormierung","flagRandS",0
		FF_SetControl "Formatnormierung","flagVerzerr",0
		FF_EnableControl "Formatnormierung","boolPaarig",true
		FF_EnableControl "Formatnormierung","WertSteg",true
		FF_EnableControl "Formatnormierung","boolFreiflaeche",true
		if  FF_GetControl("Formatnormierung","boolPaarig") = 1 or _
			FF_GetControl("Formatnormierung","boolFreiflaeche") = 1then
			FF_EnableControl "Formatnormierung","flagQH_erhalten",false
		end if
	Case "flagVerzerr"
		FF_SetControl "Formatnormierung","flagVerzerr",1
		FF_SetControl "Formatnormierung","flagBSaltEW",0
		FF_SetControl "Formatnormierung","flagRandV",0
		FF_SetControl "Formatnormierung","flagRandS",0
		FF_SetControl "Formatnormierung","flagBeschnitt",0
		FF_EnableControl "Formatnormierung","boolPaarig",true
		FF_EnableControl "Formatnormierung","WertSteg",true
		FF_EnableControl "Formatnormierung","boolFreiflaeche",true
		if  FF_GetControl("Formatnormierung","boolPaarig") = 1 or _
			FF_GetControl("Formatnormierung","boolFreiflaeche") = 1then
			FF_EnableControl "Formatnormierung","flagQH_erhalten",false
		end if
	
	Case "..."					'Ablageordner
		FF_SetCurrentPath FF_GetImagePath
		Ablage = FF_EnterPath(false,"Wahl des Ablageordners")
		if len(Ablage) > 2 then 
			if right(Ablage,1) <> "\" then Ablage = Ablage & "\"
			FF_SetControl "Formatnormierung","Ablage",Ablage
		end if
	Case "boolNichtSpeichern"
		if FF_GetControl("Formatnormierung","boolNichtSpeichern") = 1 then
			FF_EnableControl "Formatnormierung","Qualitaet",false
			FF_EnableControl "Formatnormierung","boolExifLoeschen",false
			FF_EnableControl "Formatnormierung","Ablage",false
		else
			FF_EnableControl "Formatnormierung","Qualitaet",true
			FF_EnableControl "Formatnormierung","boolExifLoeschen",true
			FF_EnableControl "Formatnormierung","Ablage",true
		end if
	Case "?"
		'FF_SetControl "Formatnormierung","Fortschritt",65	'############## nur fr Screenshot
		Anzeige = """" & FF_GetScriptPath & "\MeckiScript\Formatnormierung\Formatnormierung.pdf" & """"
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?)." & vbNewLine & vbNewLine &_
				   "Ersatzweise erfolgt eine Textanzeige!",vbExclamation,"Hinweis"
			err.clear
			
			if not KBvorhanden then	call KurzbeschreibungLesen
			if KBvorhanden then
				call KurzbeschreibungAnzeigen
			else
				msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
			end if
			
		end if
		on error GoTo 0
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Start"
		Abbruch = false
		call WerteAuslesen
		call Kontrolle
		if not Abbruch then	
			call Schleife
			exit do
		end if
	Case "CANCEL","Abbrechen"
		Abbruch = true
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Formatnormierung")

if boolPaarig = 0 then
	msg = "Von " & img+1 & " Bildern wurden " & Anzahl & " Bilder angepasst."
else
	msg = "Von " & img+1 & " Bildern wurden " & Anzahl & " Bildpaare erzeugt und angepasst."
end if

if flagQuer and nHoch > 0 then
	msg = msg & vbNewLine & nHoch & " Bilder entsprachen nicht der Option 'nur Querformate'."
end if
if flagHoch and nQuer > 0 then
	msg = msg & vbNewLine & nQuer & " Bilder entsprachen nicht der Option 'nur Hochformate'."
end if

if Nur1x = 1 then
	msg = msg & vbNewLine & vbNewLine & "Weitere Bilder wurden nicht bearbeitet weil die" & vbNewLine & "Option 'Nicht speichern' aktiviert war."
end if

if not Abbruch and not SkriptKill then
	if Nur1x = 1 then
		if flagQuer and nHoch > 0 or flagHoch and nQuer > 0 then
			msgbox "Das Bild entspricht nicht der Option" & vbNewLine & "'nur Quer-' bzw. 'nur Hochformate'!",vbInformation,"Schlussmeldung"
		end if
	else
		msgbox msg,vbInformation,"Schlussmeldung"	
	end if
end if
if SkriptKill then call KillSkript	'ggf. Skript komplett entfernen

End Sub
'---------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim Breite	: Breite = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",Breite,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,Breite,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",Breite/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop

call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen

on error resume next

Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
end if

on error goto 0
if Abbruch then exit sub

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub WerteAuslesen

'Auswahl
if FF_GetControl ("Formatnormierung","allCV") = "1" then Auswahl = 0	'alle Dateien der Computeransicht
if FF_GetControl ("Formatnormierung","selCV") = "1" then Auswahl = 1	'markierte Dateien der Computeransich
if FF_GetControl ("Formatnormierung","allBL") = "1" then Auswahl = 2	'alle Dateien der aktuellen Bilderliste
if FF_GetControl ("Formatnormierung","selBL") = "1" then Auswahl = 3	'markierte Dateien der aktuellen Bilderliste

'Breite, Hhe, Rand
WertBreite = FF_GetControl("Formatnormierung","WertBreite") * 1
WertHoehe = FF_GetControl ("Formatnormierung","WertHoehe") * 1
WertRand = FF_GetControl ("Formatnormierung","WertRand") * 1

'Randfarbe
FarbFaktor = FF_GetControl ("Formatnormierung","WertFarbe")
FarbWert = split(FarbFaktor," ")

'Hintergrundfarbe
FarbFaktorHG = FF_GetControl ("Formatnormierung","HgFarbe")
FarbWertHG = split(FarbFaktorHG," ")

'Paarig und Freiflche
boolPaarig = FF_GetControl ("Formatnormierung","boolPaarig")
WertSteg = FF_GetControl ("Formatnormierung","WertSteg")
boolFreiflaeche = FF_GetControl ("Formatnormierung","boolFreiflaeche")

'Speicheroptionen
Qualitaet =  FF_GetControl("Formatnormierung","Qualitaet") * 1
boolExifLoeschen = FF_GetControl("Formatnormierung","boolExifLoeschen")

'Nachschrfen
boolYSch = FF_GetControl ("Formatnormierung","boolYSch")
boolRGB = FF_GetControl ("Formatnormierung","boolRGB")
WertYSch = FF_GetControl ("Formatnormierung","WertYSch") * 1
WertRGB = FF_GetControl ("Formatnormierung","WertRGB") * 1

'Formatfilter
flagQuer = FF_GetControl ("Formatnormierung","flagQuer")
flagHoch = FF_GetControl ("Formatnormierung","flagHoch")
if flagQuer = 0 and flagHoch = 0 then flagQH = 1 else flagQH = 0
flagQH_erhalten = FF_GetControl ("Formatnormierung","flagQH_erhalten")

'Formatanpassung
flagRandV = FF_GetControl ("Formatnormierung","flagRandV")
flagRandS = FF_GetControl ("Formatnormierung","flagRandS")
if flagRandV = 1 or flagRandS = 1 then AnpassKennung = "Randvergroesserung"
flagBSaltEW = FF_GetControl ("Formatnormierung","flagBSaltEW")
if flagBSaltEW = 1 then AnpassKennung = "Beschnitt"
boolLiOb = FF_GetControl ("Formatnormierung","boolLiOb")
boolReUn = FF_GetControl ("Formatnormierung","boolReUn")
flagBeschnitt = FF_GetControl ("Formatnormierung","flagBeschnitt")
if flagBeschnitt = 1 then AnpassKennung = "Beschnitt"
flagVerzerr = FF_GetControl ("Formatnormierung","flagVerzerr")
if flagVerzerr = 1 then AnpassKennung = "Verzerrung"

B1zuB2 = FF_GetControl ("Formatnormierung","B1zuB2")

'Ablageordner
Ablage = FF_GetControl ("Formatnormierung","Ablage")

'Nicht speichern
Nur1x = FF_GetControl ("Formatnormierung","boolNichtSpeichern")

'Prfix aus
notPraefix = FF_GetControl ("Formatnormierung","notPraefix")

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen
Dim Array,element

'Auswahl
Auswahl = FF_GetProfile (RegSchluessel,"Auswahl")

'Breite, Hhe, Rand
WertBreite = FF_GetProfile (RegSchluessel,"WertBreite")
if WertBreite = "" then WertBreite = 800
WertHoehe = FF_GetProfile (RegSchluessel,"WertHoehe")
if WertHoehe = "" then WertHoehe = 600
WertRand = FF_GetProfile (RegSchluessel,"WertRand")
if WertRand = "" then WertRand = 4

'Randfarbe
FarbFaktor = FF_GetProfile(RegSchluessel,"FarbFaktor")
if FarbFaktor = "" then FarbFaktor = "255 255 255"

'Hintergrundfarbe
FarbFaktorHG = FF_GetProfile(RegSchluessel,"FarbFaktorHG")
if FarbFaktorHG = "" then FarbFaktorHG = "000 000 000"

'Paarig und Freiflche
boolPaarig = FF_GetProfile(RegSchluessel,"boolPaarig")
if boolPaarig = "" then boolpaarig = 0
WertSteg = FF_GetProfile(RegSchluessel,"WertSteg")
if WertSteg = "" then WertSteg = 0
boolFreiflaeche = FF_GetProfile(RegSchluessel,"boolFreiflaeche")
if boolFreiflaeche = "" then boolFreiflaeche = 0

'Formatfilter
flagQuer = FF_GetProfile(RegSchluessel,"flagQuer")
if flagQuer = "" then flagQuer = 0
flagHoch = FF_GetProfile(RegSchluessel,"flagHoch")
if flagHoch = "" then flagHoch = 0
if flagQuer = 0 and flagHoch = 0 then flagQH = 1 else flagQH = 0
flagQH_erhalten = FF_GetProfile(RegSchluessel,"flagQH_erhalten")
if flagQH_erhalten = "" then flagQH_erhalten = 0

'Formatanpassung
AnpassKennung = FF_GetProfile(RegSchluessel,"AnpassKennung")
if AnpassKennung = "" then AnpassKennung = "Beschnitt"
flagBSaltEW = FF_GetProfile(RegSchluessel,"flagBSaltEW")
if flagBSaltEW = "" then flagBSaltEW = 0
flagRandS = FF_GetProfile(RegSchluessel,"flagRandS")
if flagRandS = "" then flagRandS = 0
boolLiOb = FF_GetProfile(RegSchluessel,"boolLiOb")
if boolLiOb = "" then boolLiOb = 1
boolReUn = FF_GetProfile(RegSchluessel,"boolReUn")
if boolReUn = "" then boolReUn = 1
Markierung = FF_GetProfile(RegSchluessel,"Markierung")
if Markierung = "" then Markierung = 0
B1zuB2 = FF_GetProfile(RegSchluessel,"B1zuB2")
if B1zuB2 = "" then B1zuB2 = "50:50"

'Speicheroptionen
Qualitaet =  FF_GetProfile(RegSchluessel,"Qualitaet")
if Qualitaet = "" then Qualitaet = 85
boolExifLoeschen = FF_GetProfile(RegSchluessel,"boolExifLoeschen")
if boolExifLoeschen = "" then boolExifLoeschen = 0

'Nachschrfen
boolYSch = FF_GetProfile(RegSchluessel,"boolYSch")
if boolYSch = "" then boolYSch = 1
boolRGB = FF_GetProfile(RegSchluessel,"boolRGB")
if boolRGB = "" then boolRGB = 1
WertYSch = FF_GetProfile(RegSchluessel,"WertYSch")
if WertYSch = "" then WertYSch = 20
WertRGB = FF_GetProfile(RegSchluessel,"WertRGB")
if WertRGB = "" then WertRGB = 20

'Ablageordner
Ablage = FF_GetProfile (RegSchluessel,"Ablage")
if Ablage = "" then Ablage = "C:\"

'Nicht speichern
Nur1x = FF_GetProfile (RegSchluessel,"Nur1x")
if Nur1x = "" then Nur1x = 0

'Prfix aus
notPraefix = FF_GetProfile (RegSchluessel,"notPraefix")
if notPraefix = "" then notPraefix = 0

'### Werte eintragen
'Auswahl
if Auswahl = "" then Auswahl = 0

select case Auswahl
	Case 0
		FF_SetControl "Formatnormierung","allCV",1
	Case 1
		FF_SetControl "Formatnormierung","selCV",1
	Case 2
		FF_SetControl "Formatnormierung","allBL",1
	Case 3
		FF_SetControl "Formatnormierung","selBL",1
Case else
End select

'Breite, Hhe, Rand
FF_SetControl "Formatnormierung","WertBreite",WertBreite
FF_SetControl "Formatnormierung","WertHoehe",WertHoehe
FF_SetControl "Formatnormierung","WertRand",WertRand

'Randfarbe
FF_SetControl "Formatnormierung","WertFarbe",FarbFaktor

'Hintergrundfarbe
FF_SetControl "Formatnormierung","HgFarbe",FarbFaktorHG

'Paarig und Freiflche
FF_SetControl "Formatnormierung","boolPaarig",boolPaarig
FF_SetControl "Formatnormierung","WertSteg",WertSteg
FF_SetControl "Formatnormierung","boolFreiflaeche",boolFreiflaeche

'Formatfilter
FF_SetControl "Formatnormierung","flagQuer",flagQuer
FF_SetControl "Formatnormierung","flagHoch",flagHoch
FF_SetControl "Formatnormierung","flagQH_erhalten",flagQH_erhalten

'Formatanpassung
FF_SetControl "Formatnormierung","flagRandV",0
FF_SetControl "Formatnormierung","flagRandS",0
FF_SetControl "Formatnormierung","boolLiOb",boolLiOb
FF_SetControl "Formatnormierung","boolReUn",boolReUn
FF_SetControl "Formatnormierung","flagBeschnitt",0
FF_SetControl "Formatnormierung","flagVerzerr",0

select case AnpassKennung
	case "Randvergroesserung"
		if flagRandS = 1 then
			FF_SetControl "Formatnormierung","flagRandS",1
			FF_SetControl "Formatnormierung","flagRandV",0
		else
			FF_SetControl "Formatnormierung","flagRandS",0
			FF_SetControl "Formatnormierung","flagRandV",1
		end if
	case "Beschnitt"
		if flagBSaltEW = 1 then
			FF_SetControl "Formatnormierung","flagBSaltEW",1
			FF_SetControl "Formatnormierung","flagRandV",1
		else
			FF_SetControl "Formatnormierung","flagBeschnitt",1
		end if
	case "Verzerrung"
		FF_SetControl "Formatnormierung","flagVerzerr",1
case else
end select

Array = split(VB1zuB2,"/")
for each element in Array
	FF_SetControl "Formatnormierung","B1zuB2",element
next
FF_SetControl "Formatnormierung","B1zuB2",B1zuB2

'Speicheroptionen
FF_SetControl "Formatnormierung","Qualitaet",Qualitaet
FF_SetControl "Formatnormierung","boolExifLoeschen",boolExifLoeschen

'Nachschrfen
FF_SetControl "Formatnormierung","boolYSch",boolYSch
FF_SetControl "Formatnormierung","boolRGB",boolRGB
FF_SetControl "Formatnormierung","WertYSch",WertYSch
FF_SetControl "Formatnormierung","WertRGB",WertRGB

'Ablageordner
FF_SetControl "Formatnormierung","Ablage",Ablage

'Nicht speichern
FF_SetControl "Formatnormierung","boolNichtSpeichern",Nur1x

'Prfix aus
FF_SetControl "Formatnormierung","notPraefix",notPraefix

'Steuerelemnente aktivieren bzw. deaktivieren
if FF_GetControl("Formatnormierung","boolPaarig") = 1 or _
	FF_GetControl("Formatnormierung","boolFreiflaeche") = 1  then
	FF_EnableControl "Formatnormierung","flagQH_erhalten",false
end if

if FF_GetControl("Formatnormierung","flagBeschnitt") = 0 and _
	FF_GetControl("Formatnormierung","flagVerzerr") = 0  then
	FF_EnableControl "Formatnormierung","boolPaarig",false
	FF_EnableControl "Formatnormierung","boolFreiflaeche",false
	FF_EnableControl "Formatnormierung","flagQH_erhalten",true
end if	
	
if FF_GetControl("Formatnormierung","boolNichtSpeichern") = 1 then
	FF_EnableControl "Formatnormierung","Qualitaet",false
	FF_EnableControl "Formatnormierung","boolExifLoeschen",false
	FF_EnableControl "Formatnormierung","Ablage",false
else
	FF_EnableControl "Formatnormierung","Qualitaet",true
	FF_EnableControl "Formatnormierung","boolExifLoeschen",true
	FF_EnableControl "Formatnormierung","Ablage",true
end if

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call WerteAuslesen

'Auswahl
FF_WriteProfile RegSchluessel,"Auswahl",Auswahl

'Breite, Hhe, Rand
FF_WriteProfile RegSchluessel,"WertBreite",WertBreite
FF_WriteProfile RegSchluessel,"WertHoehe",WertHoehe
FF_WriteProfile RegSchluessel,"WertRand",WertRand

'Randfarbe
FF_WriteProfile RegSchluessel,"FarbFaktor",FarbFaktor

'Hintergrundfarbe
FF_WriteProfile RegSchluessel,"FarbFaktorHG",FarbFaktorHG

'Paarig und Freiflche
FF_WriteProfile RegSchluessel,"boolPaarig",boolPaarig
FF_WriteProfile RegSchluessel,"WertSteg",WertSteg
FF_WriteProfile RegSchluessel,"boolFreiflaeche",boolFreiflaeche

'Formatfilter
FF_WriteProfile RegSchluessel,"flagQuer",flagQuer
FF_WriteProfile RegSchluessel,"flagHoch",flagHoch
FF_WriteProfile RegSchluessel,"flagQH_erhalten",flagQH_erhalten

'Formatanpassung
FF_WriteProfile RegSchluessel,"AnpassKennung",AnpassKennung
FF_WriteProfile RegSchluessel,"flagBSaltEW",flagBSaltEW
FF_WriteProfile RegSchluessel,"flagRandS",flagRandS
FF_WriteProfile RegSchluessel,"boolLiOb",boolLiOb
FF_WriteProfile RegSchluessel,"boolReUn",boolReUn
FF_WriteProfile RegSchluessel,"Markierung",Markierung
FF_WriteProfile RegSchluessel,"B1zuB2",B1zuB2

'Speicheroptionen
FF_WriteProfile RegSchluessel,"Qualitaet",Qualitaet
FF_WriteProfile RegSchluessel,"boolExifLoeschen",boolExifLoeschen

'Nachschrfen
FF_WriteProfile RegSchluessel,"boolYSch",boolYSch
FF_WriteProfile RegSchluessel,"boolRGB",boolRGB
FF_WriteProfile RegSchluessel,"WertYSch",WertYSch
FF_WriteProfile RegSchluessel,"WertRGB",WertRGB

'Ablageordner
FF_WriteProfile RegSchluessel,"Ablage",Ablage

'Nicht speichern
FF_WriteProfile RegSchluessel,"Nur1x",Nur1x

'Prfix aus
FF_WriteProfile RegSchluessel,"notPraefix",notPraefix

End Sub
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
Dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Sub Kontrolle
Dim  BAnzahl,Text,Ja : Ja = false

Abbruch = false
Bilder = FF_GetSelection(Auswahl)

'Versionstest
if Auswahl > 1 then		'Auswahl aktiver Bilderliste
	if not Version_OK("2.90.0") then
		msgbox "Um die Auswahl aktiver Bilderlisten nutzen zu knnen" & vbNewLine & _
			   "ist mindestens FixFoto-Version 2.90 erforderlich.",vbCritical,"Hinweis"
		Abbruch = true
		exit sub
	end if
end if

'Bild vorhanden?
Bilder = FF_GetSelection(Auswahl)

if Auswahl = 0 or Auswahl = 2 then Text = "vorhanden!" else Text = "markiert!"
if len(Bilder) = 0 then
	msgbox "Es ist kein Bild " & Text,vbExclamation,"Meldung"
	Abbruch = true
	exit sub	
end if

'Zielvorgaben fr ein Querformat		/ ### mit Ja = false ausgeblendet
if Ja and WertHoehe > WertBreite then
	Antwort = msgbox("Die Zielvorgaben entsprechen einem Hochformat." & vbNewLine & _
					"Gedacht ist das Skript aber zur Erstellung von querformatigen Bildern" & vbNewLine & vbNewLine & _
					"Soll das Skript trotzdem ausgefhrt werden?",vbYesNo or vbQuestion,"Abfrage")
	if Antwort = vbNo then
		Abbruch = true
		exit sub
	end if
end if

'Wertrand nicht zu gro
if WertRand > WertBreite/4 or WertRand > WertHoehe/4 then
	msgbox 	"Der Wert fr die Umrandung sollte kleiner sein" & vbNewLine & _
			"als ein Viertel der Zielbreite bzw. Zielhhe.",vbCritical,"Hinweis"
	Abbruch = true
	exit sub
end if

'Qualitt in Ordnung
if Qualitaet = 0 then
elseif Qualitaet < 70 or Qualitaet > 100 then
	msgbox 	"Die vorgegebene Speicherqualitt sollte zwischen 70 und 100 liegen" & vbNewLine & _
			"oder = 0 sein, was dem Einstellungswert bei FF entspricht.",vbCritical,"Hinweis"
	Abbruch = true
	exit sub
end if

'Nachschrfungswerte
if WertYSch > 512 or WertRGB > 512 then
	msgbox 	"Der Werte fr das Nachschrfen drfen maximal 512 betragen!",vbCritical,"Hinweis"
	Abbruch = true
	exit sub
end if

'Ablageort vorhanden?
if not objFS.FolderExists(Ablage) then
	msgbox "Der Ablageordner " & Ablage & " existiert nicht!",vbExclamation,"Meldung"
	Abbruch = true
	exit sub
end if	

End Sub
'------------------------------------------------------------------------
Sub Abfrage

'** Start Dialog Abfrage **
FF_AddDialog "Abfrage",153,50
FF_AddControl "Abfrage","Soll nach Abbruch des Schnittdialogs die","STATIC",22,5,110,10
FF_SetControlStyle "Abfrage","Soll nach Abbruch des Schnittdialogs die",1
FF_AddControl "Abfrage","Formatanpassung durch Farbrand erfolgen?","STATIC",22,15,110,10
FF_SetControlStyle "Abfrage","Formatanpassung durch Farbrand erfolgen?",1
FF_AddControl "Abfrage","Ja bei diesem Bild","BUTTON",5,33,50,11
FF_AddControl "Abfrage","Ja bei allen Bildern","BUTTON",60,33,50,11
FF_AddControl "Abfrage","Nein","BUTTON",115,33,33,11
'** End Dialog Abfrage **

do
	Select Case FF_ShowDialog ("Abfrage")
	Case "Ja bei diesem Bild"
		RV_Aktion = true
		exit do
	Case "Ja bei allen Bildern"
		RV_AktionImmer = true
		RV_Aktion = true
		exit do
	Case "Nein","CANCEL"
		RV_Aktion = false
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Abfrage")

End Sub
'------------------------------------------------------------------------
Sub Schleife

'Bilder in Array eintragen
ListeBilder = split(Bilder, vbNewLine)
img = ubound(ListeBilder)

n = 0 : nQuer = 0 : nHoch = 0
do
	'vorzeitiger Abbruch?
	if FF_CheckKey() = 8 then 	'8 = Backspace
		Antwort = msgbox("Von " & img +1 & " Bildern wurden bisher " & n & _
					 " Bilder angepasst." & vbNewLine & vbNewLine & _
					 "Soll die weitere Normierung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		if Antwort = vbYes then Abbruch = true : exit sub
	end if
	
	'Ausfiltern des ersten Bildes
		if flagQH = 1 or flagQH_erhalten = 1 then
			Bild1 = ListeBilder(n)
		else
			if flagHoch then
				do
					Bild1 = ListeBilder(n)
					if FF_GetImageFileHeight(Bild1) >= FF_GetImageFileWidth(Bild1) then
						exit do
					else
						nQuer = nQuer +1
						n = n + 1
						if n > img then exit do
					end if
				loop
			elseif flagQuer then
				do
					Bild1 = ListeBilder(n)
					if FF_GetImageFileWidth(Bild1) > FF_GetImageFileHeight(Bild1) then
						exit do
					else
						nHoch = nHoch +1
						n = n + 1
						if n > img then exit do
					end if
				loop
			end if
		end if
	
		if n > img then exit do
	
	'Ausfiltern des zweiten Bildes bei paariger Anordnung
	if boolPaarig = 1 then
		n = n + 1

		if n > img then
			msgbox "Zu " & Bild1 & vbNewline & "ist kein Paarbild mehr vorhanden!",vbInformation,"Hinweis"
			exit do
		end if	

		if flagQH = 1 or flagQH_erhalten = 1 then
			Bild2 = ListeBilder(n)
		else
			if flagHoch then
				do
					Bild2 = ListeBilder(n)
					if FF_GetImageFileHeight(Bild2) > FF_GetImageFileWidth(Bild2) then
						exit do
					else
						nQuer = nQuer +1
						n = n + 1
						if n > img then exit do
					end if
				loop
			elseif flagQuer then
				do
					Bild2 = ListeBilder(n)
					if FF_GetImageFileWidth(Bild2) >= FF_GetImageFileHeight(Bild2) then
						exit do
					else
						nHoch = nHoch +1
						n = n + 1
						if n > img then exit do
					end if
				loop
			end if
		end if
	
		if n > img then exit do
	end if
	
	'Bearbeitung
	FF_LoadImage Bild1
	
	if boolPaarig = 1 then
		call Normierung_Paarig
	elseif boolFreiflaeche = 1 then
		call Normierung_Flaeche
	else
		call Normierung_Einfach
	end if
	
	'Fortschritt
	n = n + 1
	FF_SetControl "Formatnormierung","Fortschritt",n/(img+1)*100
	if n > img then exit do
	if Nur1x = 1 then exit do
loop

End Sub
'------------------------------------------------------------------------
Sub Normierung_Einfach

Dim Bildbreite,Bildhoehe,VB_Hoehe_Breite,HoeheTemp
Dim ZielHoehePx,ZielBreitePx,RandKorrB,RandKorrH
Dim ErweitVertOb,ErweitVertUn,ErweitHorRe,ErweitHorLi
Dim Pos

RV_flag = false
Bildbreite = FF_GetImageWidth *1
Bildhoehe  = FF_GetImageHeight *1
WertBreite = FF_GetControl("Formatnormierung","WertBreite") *1
WertHoehe = FF_GetControl ("Formatnormierung","WertHoehe") *1

if flagQH_erhalten = 1 then
	if not (WertHoehe > WertBreite xor Bildbreite > Bildhoehe) then
		HoeheTemp = WertHoehe
		WertHoehe = WertBreite
		WertBreite = HoeheTemp
	end if
end if

VB_Hoehe_Breite = (WertHoehe - 2 * WertRand) / (WertBreite - 2 * WertRand)
if boolFreiflaeche = 0 then
	select case AnpassKennung
		case "Beschnitt"
			ZielHoehePx  = Bildhoehe
			ZielBreitePx = round(Bildhoehe / VB_Hoehe_Breite)
			if ZielBreitePx > Bildbreite then
				ZielBreitePx = Bildbreite
				ZielHoehePx = round(Bildbreite * VB_Hoehe_Breite)
			end if
			
			call Beschneiden (ZielBreitePx,ZielHoehePx,Bildbreite,Bildhoehe)
			if RV_Aktion then RV_flag = true else RV_flag = false
			if Abbruch then Abbruch = false : exit sub
			
		case "Randvergroesserung"
			RV_flag = true
			
		case "Verzerrung"
	
	case else
	end select
else
	RV_flag = true
end if

'Randvergroesserung
if RV_flag then
	ZielHoehePx  = Bildhoehe
	ZielBreitePx = round(Bildhoehe / VB_Hoehe_Breite)
	RandKorrB = WertRand * ZielBreitePx/WertBreite
	RandKorrH = WertRand * ZielHoehePx/WertHoehe
	
	if ZielBreitePx < Bildbreite then						'oben/unten erweitern
		ZielBreitePx = Bildbreite
		ZielHoehePx = round(Bildbreite * VB_Hoehe_Breite)
		if boolLiOb = 1 and boolReUn = 1 then
			ErweitVertOb = round((ZielHoehePx - Bildhoehe) / 2)
			ErweitVertUn = ErweitVertOb
		elseif boolLiOb = 1 and boolReUn = 0 then
			ErweitVertOb = round(ZielHoehePx - Bildhoehe)
			ErweitVertUn = 0
		elseif boolLiOb = 0 and boolReUn = 1 then
			ErweitVertOb = 0
			ErweitVertUn = round(ZielHoehePx - Bildhoehe)
		else
			msgbox "Einstellungsfehler bei Randvergrerung!",vbExclamation,"Schwerer Fehler"
		end if
	else													'links/rechts erweitern
		if boolLiOb = 1 and boolReUn = 1 then
			ErweitHorRe = round((ZielBreitePx - Bildbreite) / 2)
			ErweitHorLi = ErweitHorRe
		elseif boolLiOb = 1 and boolReUn = 0 then
			ErweitHorRe = 0
			ErweitHorLi = round(ZielBreitePx - Bildbreite)
		elseif boolLiOb = 0 and boolReUn = 1 then
			ErweitHorRe = round(ZielBreitePx - Bildbreite)
			ErweitHorLi = 0
		else
			msgbox "Einstellungsfehler bei Randvergrerung!",vbExclamation,"Schwerer Fehler"
		end if
	end if
		
	if flagRandS = 1 then
		FF_AdvanceImage ErweitHorLi,ErweitHorRe,ErweitVertOb,ErweitVertUn
		FF_HQScale WertBreite - 2* WertRand,WertHoehe - 2* WertRand,false
		FF_ExtendCanvas WertRand,WertRand,WertRand,WertRand,FarbWert(0),FarbWert(1),FarbWert(2)
	else
		FF_ExtendCanvas RandKorrB,RandKorrB,RandKorrH,RandKorrH,FarbWert(0),FarbWert(1),FarbWert(2)
		FF_ExtendCanvas ErweitHorLi,ErweitHorRe,ErweitVertOb,ErweitVertUn,FarbWertHG(0),FarbWertHG(1),FarbWertHG(2)
		FF_HQScale WertBreite,WertHoehe,false
	end if
else
	FF_HQScale WertBreite - 2* WertRand,WertHoehe - 2* WertRand,false
	FF_ExtendCanvas WertRand,WertRand,WertRand,WertRand,FarbWert(0),FarbWert(1),FarbWert(2)
end if

Pos = InStrRev(Bild1,"\")
if notPraefix = 0 then
	BildNeu = Praefix1 & mid(Bild1,Pos+1)
else
	BildNeu = mid(Bild1,Pos+1)
end if

call BildSpeichern

End Sub
'------------------------------------------------------------------------
Sub Normierung_Flaeche
Dim B1_Ist,H1_Ist,SV1_Ist
Dim B1_Soll,H1_Soll
Dim B1,H1,SV1,F1
Dim B,H

'Bilddaten ermitteln
B1_Ist = FF_GetImageWidth
H1_Ist = FF_GetImageHeight
SV1_Ist = B1_Ist / H1_Ist

'Berechnungen
H = WertHoehe - 2 * WertRand
B = WertBreite - 2 * WertRand


'### Bild 1
'Breitenfaktor fr Bild1
F1 = left(B1zuB2,2) / 100
B1_Soll = round(F1 * B)
H1_Soll = H
SV1 = B1_Soll / H1_Soll

'Bild1 beschneiden
B1 = B1_Ist
H1 = round(B1_Ist / SV1)
if H1 > H1_Ist then
	H1 = H1_Ist
	B1 = round(H1_Ist * SV1)
end if

if AnpassKennung = "Beschnitt" then
	call Beschneiden (B1,H1,B1_Ist,H1_Ist)
	if Abbruch then exit sub
else
	FF_HQScale B1,H1,false
end if

call Normierung_Einfach

End Sub
'------------------------------------------------------------------------
Sub Normierung_Paarig

Dim B1_Ist,H1_Ist,B2_Ist,H2_Ist,SV_Ist,SV1_Ist,SV2_Ist
Dim B1_Soll,H1_Soll,B2_Soll,H2_Soll
Dim B1,H1,SV1,F1,B2,H2,SV2
Dim Links,Rechts,Oben,Unten,X_Start,Y_Start
Dim B,H,Pos,Rand

'Bilddaten ermitteln
B1_Ist = FF_GetImageWidth
H1_Ist = FF_GetImageHeight
SV1_Ist = B1_Ist / H1_Ist
B2_Ist = FF_GetImageFileWidth(Bild2)
H2_Ist = FF_GetImageFileHeight(Bild2)
SV2_Ist = B2_Ist / H2_Ist

'Berechnungen
H = WertHoehe - 2 * WertRand
B = WertBreite - 2 * WertRand - WertSteg

RV_flag = false
Bild2InBearbeitung = false
select case AnpassKennung
	case "Beschnitt","Verzerrung"

		'### Bild 1
		'Breitenfaktor fr Bild1
		F1 = left(B1zuB2,2) / 100	
		
		B1_Soll = round(F1 * B)
		H1_Soll = H
		SV1 = B1_Soll / H1_Soll

		'Bild1 beschneiden
		B1 = B1_Ist
		H1 = round(B1_Ist / SV1)
		if H1 > H1_Ist then
			H1 = H1_Ist
			B1 = round(H1_Ist * SV1)
		end if
		
		if AnpassKennung = "Beschnitt" then
			call Beschneiden (B1,H1,B1_Ist,H1_Ist)
			if Abbruch then exit sub
		end if
		
	if not RV_flag then
		'Skalieren und Erweitern
		FF_HQScale B1_Soll,H1_Soll,false
		Links = WertRand
		Rechts = WertBreite - WertRand - B1_Soll
		Oben  = WertRand
		Unten = WertRand
		FF_ExtendCanvas Links,Rechts,Oben,Unten,FarbWert(0),FarbWert(1),FarbWert(2)
		FF_PushImage

		'### Bild 2
		B2_Soll = B - B1_Soll
		H2_Soll = H
		SV2 = B2_Soll / H2_Soll

		'Bild2 beschneiden
		B2 = B2_Ist
		H2 = round(B2_Ist / SV2)
		if H2 > H2_Ist then
			H2 = H2_Ist
			B2 = round(H2_Ist * SV2)
		end if

		FF_LoadImage Bild2
		Bild2InBearbeitung = true
		if AnpassKennung = "Beschnitt" then
			call Beschneiden (B2,H2,B2_Ist,H2_Ist)
			if Abbruch then exit sub
		end if

		'### Mischen
		X_Start = WertBreite - B2_Soll - WertRand
		Y_Start = Oben
	end if
	
	case "Randvergroesserung"
		RV_flag = true
case else
end select

if RV_flag then
	do
		H1_Soll = H
		B1_Soll = round(H1_Soll * SV1_Ist)
		H2_Soll = H
		B2_Soll = round(H2_Soll * SV2_Ist)
		if (B1_Soll + B2_Soll) <= B then exit do else H = H - 1
	loop
		
	Rand = round((WertBreite - B1_Soll - B2_Soll - WertSteg) / 2)
	if (Rand > WertRand*1) and (Rand > WertSteg*1) then
		Rand = round((WertBreite - B1_Soll - B2_Soll) / 3)
	end if
	Links = Rand
	Rechts = WertBreite - B1_Soll - Rand
	Oben = round((WertHoehe - H1_Soll) / 2)
	Unten = WertHoehe - H1_Soll - Oben

	X_Start = WertBreite - B2_Soll - Rand
	Y_Start = Oben

	'Skalieren, Erweitern und 
	FF_HQScale B1_Soll,H1_Soll,false
	FF_ExtendCanvas Links,Rechts,Oben,Unten,FarbWert(0),FarbWert(1),FarbWert(2)
	FF_PushImage
	FF_LoadImage Bild2		
end if
	
FF_MixImage X_Start,Y_Start,B2_Soll,H2_Soll,255
FF_PopImage
	
'Abspeichern
Pos = InStrRev(Bild1,"\")
Kommentar = mid(Bild1,Pos+1)
if notPraefix = 0 then
	BildNeu = Praefix2 & Kommentar
else
	BildNeu = Kommentar
end if
Pos = InStrRev(Bild2,"\")
Kommentar = "Bildpaar " & Kommentar & " und " & mid(Bild2,Pos+1)

call BildSpeichern

End Sub
'------------------------------------------------------------------------
Sub BildSpeichern
Dim strExtension,strName,m
Dim Artist,Copyright1,Copyright2

'Bild Nachschrfen
if boolYSch = 1 then FF_YSharp WertYSch
if boolRGB = 1 then FF_Sharp WertRGB,true,true,true

'Exif-/IPTC-Daten behandeln
if boolExifLoeschen = 1 and Nur1x = 0 then
	if FF_HasExif then FF_KillExif
	if FF_HasIPTC then FF_KillIPTC
elseif boolPaarig = 1 then
	FF_KillIPTC
	if FF_HasExif then
		Artist = FF_GetExifTag("Artist")
		Copyright1 = FF_GetExifTag("Copyright1")
		Copyright2 = FF_GetExifTag("Copyright2")
		FF_KillExif
		FF_CreateExif()
		FF_SetExifTag "Artist",Artist
		FF_SetExifTag "Copyright1",Copyright1
		FF_SetExifTag "Copyright2",Copyright2
		FF_SetExifTag "UserComment",Kommentar
	end if
end if


'Bild speichern
FF_SetDPI 72

if Nur1x = 1 then
	FF_Reload
else

	strExtension = "." & objFS.GetExtensionName(BildNeu)
	strName = objFS.GetBaseName(BildNeu)

	'vorhandene Bilder nummerieren mit (1), (2) usw.
	if objFS.FileExists(Ablage & BildNeu) then
		m = 1
		do
			BildNeu = Ablage & strName & "(" & m & ")" & strExtension
			if not objFS.FileExists(BildNeu) then exit do
			m = m + 1
		loop
	else
		BildNeu = Ablage & strName & strExtension
	end if

	FF_SaveImage BildNeu,Qualitaet
end if
Anzahl = Anzahl + 1

End Sub
'------------------------------------------------------------------------
Sub Beschneiden (Schnittbreite,Schnitthoehe,Bildbreite,Bildhoehe)
Dim SParameter,AntwortMD,SollHoch,IstHoch,msg,Param,X,Y

if Schnittbreite > Schnitthoehe then SollHoch = 1 else SollHoch = 0
if Bildbreite > Bildhoehe then IstHoch = 1 else IstHoch = 0
if Schnittbreite = Schnitthoehe then SollHoch = 1 : IstHoch = 1

if (SollHoch Xor IstHoch) = 0 then
	X = (Bildbreite - Schnittbreite) \ 2
	Y = (Bildhoehe - Schnitthoehe) \ 2
	FF_SetParam X & "," & Y & "," & Schnittbreite & "," & Schnitthoehe & "," & Bildbreite & "," & Bildhoehe & "," & Markierung & ",1"
else
	if IstHoch = 1 then 
		msg = "Ein querformatiges Bild soll hochformatig beschnitten werden."
	else
		msg = "Ein hochformatiges bzw. quadratisches Bild soll querformatig beschnitten werden."
	end if
	
	msgbox msg & vbNewLine & "Daher muss im folgenden Dialog die Taste 'Hoch/Quer' bettigt werden!", _
			   vbInformation,"Unbedingt beachten!"
	X = (Bildbreite - Schnitthoehe) \ 2
	Y = (Bildhoehe - Schnittbreite) \ 2
	FF_SetParam Y & "," & X & "," & Schnittbreite & "," & Schnitthoehe & "," & Bildhoehe & "," & Bildbreite & "," & Markierung & ",1"
end if
	
	RV_Aktion = false
	AntwortMD = FF_MultiDialog ("MultiCanvas",2)
	if AntwortMD < 0 then
		if flagBSaltEW = 1 then
			if RV_AktionImmer then
				RV_Aktion = true
				exit sub
			else
				call Abfrage
				if RV_Aktion = true then
					exit sub
				else
					'Msgbox "Die Bearbeitung des Bildes wird abgebrochen!",vbExclamation,"Hinweis"
					if Nur1x = 1 then FF_Reload
					Abbruch = true
					exit sub
				end if
			end if
		else
			msgbox "Das Bild wurde nicht beschnitten." & vbNewLine & _
					"Deshalb wird dessen Bearbeitung abgebrochen!",vbExclamation,"Hinweis"
			if Nur1x = 1 then FF_Reload
			Abbruch = true
			exit sub
		end if
	end if

'gewhlte Markierungsart speichern
Param = split(FF_GetParam,",")
Markierung = Param(6)

'Kontrolle ob Taste 'Hoch/Quer' bettigt wurde
if abs(round(Schnittbreite/Schnitthoehe,2) - round(Param(2)/Param(3),2)) > 0.01 then
	Msgbox "Das Seitenverhltnis entspricht nicht den Vorgaben." & vbNewLine & _
		   "Mglicherweise wurde 'Hoch/Quer' nicht oder flschlicherweise bettigt." & vbNewline & vbNewLine & _
		   "Die weitere Bearbeitung des Bildes bzw. Bildpaars wird abgebrochen!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub	
end if

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\Beipack.txt"		'Dateibeispiel
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

TempFile = FF_GetScriptPath & "\MeckiScript\Formatnormierung"	'Ordnerbeispiel
if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration'" & vbNewLine & _
	   "ist das Skript " & Skriptname & vbNewLine & _
	   "mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'-------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
